function C= cycle(A)
C=A;

% % One way to calculate this:
% [N1 N2]=size(A)
% for ii=1:N1
%    for jj=1:N2
%        ne=A(mod(ii-2,N1)+1,mod(jj-2,N2)+1)+A(mod(ii-2,N1)+1,mod(jj-1,N2)+1)+A(mod(ii-2,N1)+1,mod(jj,N2)+1)...
%            +A(mod(ii-1,N1)+1,mod(jj-2,N2)+1)+A(mod(ii-1,N1)+1,mod(jj-2,N2)+1)...
%            +A(mod(ii,N1)+1,mod(jj-2,N2)+1)+A(mod(ii,N1)+1,mod(jj-1,N2)+1)+A(mod(ii,N1)+1,mod(jj,N2)+1);
%        switch ne
%            case 3
%                C(ii,jj)=1;
%            case 2
%            otherwise
%                C(ii,jj)=0;
%        end
%    end
% end


% Another way to do it, more MATLAB-centric
% This calculates the number of neighbour of each cell, stores it in B
B=circshift(A,[1 1])+circshift(A,[1 0])+circshift(A,[1 -1])+circshift(A,[0 1])+circshift(A,[0 -1])+circshift(A,[-1 1])+circshift(A,[-1 0])+circshift(A,[-1 -1]);
C(B<2 | B>3)=0; % Too few/many neighbours, the cell dies % This changes only the matrix elements of C that obey the conditions 
C(B==3)=1; % 3 neighbours, the cell will be alive


clear B ii jj ne N1 N2
